//A simple GUI for visualising 3D mri images
xdel(winsid()); clear;
exec("3dmri_functions.sci",-1);
exec("scilab/readfile.sci",-1);

stacksize('max')
 
i1=uigetfile(["*.nii";"*.nii.gz";"*.hdr";"*"],"","Select MRI file");
I=loadimage(i1);

cd /home/pog/scilab/;
handles.M.value=double(max(I(:)));
handles.m.value=double(min(I(:)));

s=size(I); sm=fix(s/2);
x=1; y=1; z=1; br=1;

f=figure('figure_position',[50,50],'figure_size',[1200,1200],'auto_resize','on','background',9,'figure_name','Finestra grafica numero %d')

delmenu(f.figure_id,gettext('?'))
delmenu(f.figure_id,gettext('Tools'))
toolbar(f.figure_id,'off')
handles.dummy = 0;
handles.axial= newaxes();    handles.axial.margins = [ 0 0 0 0];    handles.axial.axes_bounds =    [0.05,0.05,0.4,0.4]; handles.axial.auto_ticks=["off","off","off"];
handles.coronal= newaxes();  handles.coronal.margins = [ 0 0 0 0];  handles.coronal.axes_bounds =  [0.55,0.05,0.4,0.4]; handles.coronal.auto_ticks=["off","off","off"];
handles.sagittal= newaxes(); handles.sagittal.margins = [ 0 0 0 0]; handles.sagittal.axes_bounds = [0.55,0.55,0.4,0.4]; handles.sagittal.auto_ticks=["off","off","off"];

handles.ax=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(3)],'Min',[1],'Position',[0.09,0.96,0.15,0.03],'Relief','flat','SliderStep',[1,2],'String','axial','Style','pushbutton','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','ax','Callback','ax_callback')
handles.cor=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(2)],'Min',[1],'Position',[0.6,0.96,0.15,0.03],'Relief','flat','SliderStep',[1,2],'String','coronal','Style','pushbutton','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','cor','Callback','cor_callback')
handles.sag=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(1)],'Min',[1],'Position',[0.6,0.46,0.15,0.03],'Relief','flat','SliderStep',[1,2],'String','sagittal','Style','pushbutton','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','sag','Callback','sag_callback')

handles.x=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(3)],'Min',[1],'Position',[0.05,0.35,0.3,0.04],'Relief','flat','SliderStep',[1,2],'String','x','Style','slider','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','x','Callback','x_callback(handles)')
handles.y=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(2)],'Min',[1],'Position',[0.05,0.3,0.3,0.04],'Relief','flat','SliderStep',[1,2],'String','y','Style','slider','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','y','Callback','y_callback(handles)')
handles.z=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(1)],'Min',[1],'Position',[0.05,0.25,0.3,0.04],'Relief','flat','SliderStep',[1,2],'String','z','Style','slider','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','z','Callback','z_callback(handles)')

handles.x1=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(3)],'Min',[1],'Position',[0.003,0.35,0.045,0.04],'Relief','flat','SliderStep',[1,2],'String',string(x),'Style','spinner','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','x1','Callback','x1_callback(handles)')
handles.y1=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(2)],'Min',[1],'Position',[0.003,0.3,0.045,0.04],'Relief','flat','SliderStep',[1,2],'String',string(y),'Style','spinner','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','y1','Callback','y1_callback(handles)')
handles.z1=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[s(1)],'Min',[1],'Position',[0.003,0.25,0.045,0.04],'Relief','flat','SliderStep',[1,2],'String',string(z),'Style','spinner','Value',[1],'VerticalAlignment','middle','Visible','on','Tag','z1','Callback','z1_callback(handles)')





handles.plot=uicontrol(f,'unit','normalized','BackgroundColor',[0.6,0.6,0.6],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[2],'Min',[0],'Position',[0.05,0.2,0.3,0.04],'Relief','raised','SliderStep',[1,2],'String','plot','Style','pushbutton','Value',[0],'VerticalAlignment','middle','Visible','on','Tag','plot','Callback','plot_callback(handles)')
handles.bright=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Enable','on','FontAngle','normal','FontName','helvetica','FontSize',[12],'FontUnits','points','FontWeight','normal','ForegroundColor',[0,0,0],'HorizontalAlignment','center','ListboxTop',[],'Max',[10],'Min',[1],'Position',[0.05,0.15,0.3,0.04],'Relief','flat','SliderStep',[1,2],'String','z','Style','slider','Value',[2],'VerticalAlignment','middle','Visible','on','Tag','bright','Callback','')


handles.d1=uicontrol(f,'unit','normalized','BackgroundColor',[0.8,0.8,0.8],'Position',[0.36,0.15,0.06,0.04],'Relief','flat','String','Brightness','Style','text','HorizontalAlignment','center')
handles.x.Value=sm(3); handles.x1.Value=sm(3);
handles.y.Value=sm(2); handles.y1.Value=sm(2);
handles.z.Value=sm(1); handles.z1.Value=sm(1);

