xdel(winsid()); clear;
exec("readfile.sci");
exec("savefile.sci");
exec("data_analize.sci");
cd data
stacksize('max')
disp("Reading Volumes...")
tic();
//datafiles conversion/import and normalization
files=ls("*.hdr"); files=strsubst(files,'.hdr','');
for i=1:3
  execstr('I'+string(i)+'=loadimage(files('+string(i)+'));'); 
end
cd /home/pog/scilab/;

time=toc();
disp(sprintf("time = %8.0f seconds",time));

h=.53
//h=.2



s=size(I1);
f0=figure(0); f0.backgroundcolor='1|1|1'; colormap gray;
subplot(1,3,1), imagesc(rot90(squeeze(I1(:,:,fix(s(1)*h)))));
subplot(1,3,2), imagesc(rot90(squeeze(I2(:,:,fix(s(1)*h))))); 
subplot(1,3,3), imagesc(rot90(squeeze(I3(:,:,fix(s(1)*h))))); 

disp("Computing joint histograms...")
//joint histogram
tic();

H12=jointh(I1(:),I2(:),1);
H13=jointh(I1(:),I3(:),1);
H23=jointh(I2(:),I3(:),1);

time=toc();
disp(sprintf("time = %8.0f seconds",time));

f=figure(1); f.backgroundcolor='1|1|1';
subplot(1,3,1), imagesc(H12(1:150,1:150),[0,2.e-4]); xlabel(files(1)); ylabel(files(2));
subplot(1,3,2), imagesc(H13(1:150,1:150),[0,2.e-4]); xlabel(files(1)); ylabel(files(3));
subplot(1,3,3), imagesc(H23(1:150,1:150),[0,2.e-4]); xlabel(files(2)); ylabel(files(3));

//peak finding and gravity map

disp("Peak finding and gravity map computing...")
tic();
pk1=findpeaks(H12,1.e-5,8); 
pk2=findpeaks(H13,1.e-5,8); 
pk3=findpeaks(H23,1.e-5,8);

A1=gravity_map(H12,pk1,1.e-11);
A2=gravity_map(H13,pk2,1.e-11);
A3=gravity_map(H23,pk3,1.e-11);


time=toc();
disp(sprintf("time = %8.2f seconds",time));


f2=figure(2); f2.backgroundcolor='1|1|1';
subplot(1,3,1), imagesc(A1(1:150,1:150)); xlabel(files(1)); ylabel(files(2));
subplot(1,3,2), imagesc(A2(1:150,1:150)); xlabel(files(1)); ylabel(files(3));
subplot(1,3,3), imagesc(A3(1:150,1:150)); xlabel(files(2)); ylabel(files(3));

//areas extraction
disp("Extraction of WM/GM/CSF...")
tic();

[I11,J11,J12,J13]=extract(I1,I2,A1,pk1);
[I22,J21,J22,J23]=extract(I1,I3,A2,pk2);
[I33,J31,J32,J33,J34]=extract(I2,I3,A3,pk3);

f3=figure(3); f3.backgroundcolor='1|1|1'; 
subplot(1,3,1), imagesc(rot90(squeeze(I11(:,:,fix(s(1)*h)))));
subplot(1,3,2), imagesc(rot90(squeeze(I22(:,:,fix(s(1)*h))))); 
subplot(1,3,3), imagesc(rot90(squeeze(I33(:,:,fix(s(1)*h))))); 

WM=intersect(J12 , J23 ,J34);
GM=intersect(J13 , J22, J33);

CSF=J32;
NonBrain=intersect(J11,J21,J31);

time=toc();
disp(sprintf("time = %8.0f seconds",time));

f4=figure(4); f4.backgroundcolor='1|1|1'; colormap gray;
im=rot90(1*squeeze(WM(:,:,fix(s(1)*h))))+2*rot90(squeeze(GM(:,:,fix(s(1)*h))));
imagesc(im); 

disp("Erode-dilate of WM/GM")
tic();

WM=opening3d(WM);
GM=opening3d(GM);

time=toc();
disp(sprintf("time = %8.0f seconds",time));

f44=figure(44); f44.backgroundcolor='1|1|1'; colormap gray;
im=rot90(1*squeeze(WM(:,:,fix(s(1)*h))))+2*rot90(squeeze(GM(:,:,fix(s(1)*h))));
imagesc(im); 

//finding lesions
disp("finding WM lesions....")
tic();
HH12=H12(pk1(3,1)+1:$,pk1(3,2)+1:$);
HH13=H13(pk2(2,1)+1:$,1:pk2(2,2)+1);
HH23=H23(pk3(3,1)+1:$,1:pk3(3,2)+1);

//peack finding
ppk1=findpeaks(HH12,1.e-6,3); pkk1=[ppk1(2:$,1)+pk1(3,1),ppk1(2:$,2)+pk1(3,2)];
ppk2=findpeaks(HH13,1.e-6,3); pkk2=[ppk2(1:$,1)+pk2(2,1),ppk2(1:$,2)];
ppk3=findpeaks(HH23,1e-6,3);pkk3=[ppk3(1:$,1)+pk3(3,1),ppk3(1:$,2)];

//non-brain and suspect GM we have to exclude as non-lesional tissue



E=ndilate3d(GM|CSF|NonBrain,5) | erode3d(WM);

Lesions=lesion_find(I1,I2,I3,E,pkk1,pkk2,pkk3);
time=toc();
disp(sprintf("time = %8.0f seconds",time));

f5=figure(5); f5.backgroundcolor='1|1|1'; colormap gray;
subplot(1,2,1), imagesc(rot90(squeeze(I2(:,:,fix(s(1)*h)))));
subplot(1,2,2), imagesc(im+rot90(squeeze(7*Lesions(:,:,fix(s(1)*h))))); 


disp("Erode-dilate lesions...")
tic();
Lesions=closing3d(Lesions);
time=toc();
disp(sprintf("time = %8.0f seconds",time));


disp(sprintf("Lesional Volume (in pixels)   %d",sum(Lesions)));

f6=figure(6); f6.backgroundcolor='1|1|1';
colormap gray;
subplot(1,2,1), imagesc(rot90(squeeze(I2(:,:,fix(s(1)*h)))));
subplot(1,2,2), imagesc(im+rot90(squeeze(7*Lesions(:,:,fix(s(1)*h))))); 

disp("Mission Completed!")
